/****************************************************************************
*   
*
*   "CoatiFrame" Release 1.28
*
*   Portions Copyright (c) 2014-2020
*   by Mellspa.
*   All rights reserved.
*   Copyrighted as an unpublished work.
*
****************************************************************************/
#include <stdafx.h>

#include <spiel.h>
#include <coatipages.h>

using namespace std;

// The definitions for the GET scheme

MSHTMLKontext_Game_Get::MSHTMLKontext_Game_Get(MSCoatiApplication2* theapp, const string& coatiid, unsigned int stack_level, map<string,string>& extended_params) 
: MSHTMLKontextN(theapp, coatiid, stack_level,"game_get.html?", extended_params, nullptr) //The ? marks the GET scheme.
{
  
  
  // now loading the game view from the HTML5, store it in thedocumentdisplayed
  _loadDocumentTemplate("spiele.html", _theapp->GetAppstorage().GetStoredPages());
  
  
   // insert the right ID into the document
  insertFormCoatiid(getMainContextID());
  
  // declare all page handlers
  
  _MS_InsertHandler(as_cmd(CommandF11),"/f11");
  _MS_InsertHandler(as_cmd(CommandF12),"/f12");
  _MS_InsertHandler(as_cmd(CommandF13),"/f13");
  _MS_InsertHandler(as_cmd(CommandF21),"/f21");
  _MS_InsertHandler(as_cmd(CommandF22),"/f22");
  _MS_InsertHandler(as_cmd(CommandF23),"/f23");
  _MS_InsertHandler(as_cmd(CommandF31),"/f31");
  _MS_InsertHandler(as_cmd(CommandF32),"/f32");
  _MS_InsertHandler(as_cmd(CommandF33),"/f33");
  
  _MS_InsertHandler(as_cmd(CommandNeuStarten),"/NeuStarten");
  _MS_InsertHandler(as_cmd(CommandGame),"/game_get.html");
  _MS_InsertHandler(as_cmd(CommandGame),"/");
  _MS_InsertHandler(as_cmd(CommandGame),"/playget");
  _MS_InsertHandler(as_cmd(CommandRunPostScheme),"/playpost");
  _MS_InsertHandler(as_cmd(CommandRunWidgetScheme),"/playwidget");
  
  //thats it
}

MSHTMLKontext_Game_Get::~MSHTMLKontext_Game_Get()
{
  // nothing to do, formally only
}


// the command handlers

void MSHTMLKontext_Game_Get::CommandF11(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("11");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Get::CommandF12(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("12");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Get::CommandF13(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("13");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Get::CommandF21(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("21");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Get::CommandF22(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("22");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Get::CommandF23(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("23");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Get::CommandF31(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("31");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Get::CommandF32(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("32");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Get::CommandF33(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("33");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Get::CommandNeuStarten(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   // The user wants the game to be initialized again.
  dreikreuze.NeuInitialisieren();
  
  _loadDocumentTemplate("spiele.html",_theapp->GetAppstorage().GetStoredPages());
  
  // insert the right ID into the document
  insertFormCoatiid(getMainContextID());
  
  // declare all page handlers
  
  _MS_InsertHandler(as_cmd(CommandF11),"/f11");
  _MS_InsertHandler(as_cmd(CommandF12),"/f12");
  _MS_InsertHandler(as_cmd(CommandF13),"/f13");
  _MS_InsertHandler(as_cmd(CommandF21),"/f21");
  _MS_InsertHandler(as_cmd(CommandF22),"/f22");
  _MS_InsertHandler(as_cmd(CommandF23),"/f23");
  _MS_InsertHandler(as_cmd(CommandF31),"/f31");
  _MS_InsertHandler(as_cmd(CommandF32),"/f32");
  _MS_InsertHandler(as_cmd(CommandF33),"/f33");
  
  _MS_InsertHandler(as_cmd(CommandNeuStarten),"/NeuStarten");
  _MS_InsertHandler(as_cmd(CommandGame),"/playget");
  _MS_InsertHandler(as_cmd(CommandRunPostScheme),"/playpost");
  _MS_InsertHandler(as_cmd(CommandRunPostScheme),"/playwidget");
  
  // send the new set page data...
  http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
  
}

void MSHTMLKontext_Game_Get::CommandGame(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
  // just show the page. It is not a real command. Useful if the browser is doing a 'reload' 
  http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}


void MSHTMLKontext_Game_Get::CommandRunPostScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
  // user wants to play the get scheme
  auto nc = new MSHTMLKontext_Game_Post(_theapp, getMainContextID(), 1, _extended_params);
  nc->manageRequest(http_ih, http_oh, "");
  http_oh.resetKontext(getMainContextID(),nc);
}


void MSHTMLKontext_Game_Get::CommandRunWidgetScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
  // user wants to play the Widget scheme
  auto nc = new MSHTMLKontext_GameWidget(_theapp, getMainContextID(), 1, _extended_params);
  nc->manageRequest(http_ih, http_oh, "");
  http_oh.resetKontext(getMainContextID(),nc);
}



void MSHTMLKontext_Game_Get::checkwin()
{
  if(dreikreuze.Gewonnen()==1)
  {
    // The user won the game. Change the element content in order to explain the new situation to the user.
    auto tmp = _thedocumentdisplayed->FindObject("id","restart");
    if(tmp)
    {
      tmp->ReplaceElement(new MSHTML_a2("#", "X wins, Restart Game"),"id","NeuStarten");
    } 
  }
  if(dreikreuze.Gewonnen()==2)
  {
    // The computer won the game. Change the element content in order to explain the new situation to the user.
    auto tmp = _thedocumentdisplayed->FindObject("id","restart");
    if(tmp)
    {
      tmp->ReplaceElement(new MSHTML_a2("#", "O wins, Restart Game"),"id","NeuStarten");
    } 
  }
  if(dreikreuze.Gewonnen()==3)
  {
    // Nobody won the game. Change the element content in order to explain the new situation to the user.
    auto tmp = _thedocumentdisplayed->FindObject("id","restart");
    if(tmp)
    {
      tmp->ReplaceElement(new MSHTML_a2("#", "nobody wins, Restart Game"),"id","NeuStarten");
    } 
  }
}


//! The user clicked on a playing field. Register it and give an reaction -> exchange the displayed image. 
void MSHTMLKontext_Game_Get::KommandoFeld(string feld)
{
  if(dreikreuze.FeldBespielbar(feld))
  {
    auto tmp = _thedocumentdisplayed->FindObject("id","i"+feld);
    if(tmp)
    {
      tmp->ReplaceAttributeContent("src","kreuz.png"); // show a cross
    }
    if(1!=dreikreuze.Gewonnen())
    {
      tmp = _thedocumentdisplayed->FindObject("id","i"+dreikreuze.GebeOFeld());
      if(tmp)
      {
        tmp->ReplaceAttributeContent("src","kreis.png"); // show a circle
      }
    }
  }
}







// The definitions for the POST scheme

MSHTMLKontext_Game_Post::MSHTMLKontext_Game_Post(MSCoatiApplication2* theapp, const string& coatiid, unsigned int stack_level, map<string,string>& extended_params) 
: MSHTMLKontextN(theapp, coatiid, stack_level,"game_post.html",extended_params,nullptr)
{
  
  // now loading the game view from the HTML5, store it in thedocumentdisplayed
  _loadDocumentTemplate("spiele_post.html",_theapp->GetAppstorage().GetStoredPages());
  
   
  // insert the right ID into the document
  insertFormCoatiid(getMainContextID());
    
  
  // declare all page handlers
  _MS_InsertHandler(as_cmd(CommandF11),"/f11");
  _MS_InsertHandler(as_cmd(CommandF12),"/f12");
  _MS_InsertHandler(as_cmd(CommandF13),"/f13");
  _MS_InsertHandler(as_cmd(CommandF21),"/f21");
  _MS_InsertHandler(as_cmd(CommandF22),"/f22");
  _MS_InsertHandler(as_cmd(CommandF23),"/f23");
  _MS_InsertHandler(as_cmd(CommandF31),"/f31");
  _MS_InsertHandler(as_cmd(CommandF32),"/f32");
  _MS_InsertHandler(as_cmd(CommandF33),"/f33");
  
  _MS_InsertHandler(as_cmd(CommandNeuStarten),"/NeuStarten");
  _MS_InsertHandler(as_cmd(CommandGame),"/game_post.html");
  _MS_InsertHandler(as_cmd(CommandGame),"/playpost");
  _MS_InsertHandler(as_cmd(CommandRunGetScheme),"/playget");
  _connect_element_method_POST("playget", onclick);
  _MS_InsertHandler(as_cmd(CommandRunWidgetScheme),"/playwidget");
  _connect_element_method_POST("playwidget", onclick);
  
  
  
  // connect the intended active elements of the document with the commands above
  _connect_element_method_POST("f11", onclick);
  _connect_element_method_POST("f12", onclick);
  _connect_element_method_POST("f13", onclick);
  _connect_element_method_POST("f21", onclick);
  _connect_element_method_POST("f22", onclick);
  _connect_element_method_POST("f23", onclick);
  _connect_element_method_POST("f31", onclick);
  _connect_element_method_POST("f32", onclick);
  _connect_element_method_POST("f33", onclick);
  _connect_element_method_POST("NeuStarten", onclick);
  //thats it
  
}

MSHTMLKontext_Game_Post::~MSHTMLKontext_Game_Post()
{
  // nothing to do, formally only
}


// the command handlers

void MSHTMLKontext_Game_Post::CommandF11(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("11");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Post::CommandF12(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("12");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Post::CommandF13(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("13");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Post::CommandF21(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("21");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Post::CommandF22(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("22");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Post::CommandF23(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("23");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Post::CommandF31(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("31");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Post::CommandF32(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("32");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Post::CommandF33(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   KommandoFeld("33");
   checkwin();
   http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}


void MSHTMLKontext_Game_Post::CommandNeuStarten(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
   // The user wants the game to be initialized again.
  dreikreuze.NeuInitialisieren();
  
  // reload the HTML5 template again
  _loadDocumentTemplate("spiele_post.html",_theapp->GetAppstorage().GetStoredPages());
  
  // insert the right ID into the document
  insertFormCoatiid(getMainContextID()); 
  
  
  // connect the intended active elements of the document with the commands above
  _connect_element_method_POST("f11", onclick);
  _connect_element_method_POST("f12", onclick);
  _connect_element_method_POST("f13", onclick);
  _connect_element_method_POST("f21", onclick);
  _connect_element_method_POST("f22", onclick);
  _connect_element_method_POST("f23", onclick);
  _connect_element_method_POST("f31", onclick);
  _connect_element_method_POST("f32", onclick);
  _connect_element_method_POST("f33", onclick);
  _connect_element_method_POST("NeuStarten", onclick);
  _connect_element_method_POST("playget", onclick);
  _connect_element_method_POST("playwidget", onclick);
  // send the new set page data...
  http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
  
}

void MSHTMLKontext_Game_Post::CommandGame(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
  // just show the page. It is not a real command. Useful if the browser is doing a 'reload' 
  http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_Game_Post::CommandRunGetScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
  // user wants to play the get scheme
  auto nc = new MSHTMLKontext_Game_Get(_theapp, getMainContextID(), 1, _extended_params);
  nc->manageRequest(http_ih, http_oh, "");
  http_oh.resetKontext(getMainContextID(),nc);
}

void MSHTMLKontext_Game_Post::CommandRunWidgetScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
  // user wants to play the Widget scheme
  auto nc = new MSHTMLKontext_GameWidget(_theapp, getMainContextID(), 1, _extended_params);
  nc->manageRequest(http_ih, http_oh, "");
  http_oh.resetKontext(getMainContextID(),nc);
}


void MSHTMLKontext_Game_Post::checkwin()
{
  if(dreikreuze.Gewonnen()==1)
  {
    // The user won the game. Change the element content in order to explain the new situation to the user.
    // The element is an underlined text. 
    auto tmp = _thedocumentdisplayed->FindObject("id","NeuStarten");
    if(tmp)
    {
      tmp->RemoveSubelements();
      MSHTML_u2* u = new MSHTML_u2();
      *u << new MSHTML_text2("X wins, Restart Game");
      *tmp << u; 
    } 
    
  }
  if(dreikreuze.Gewonnen()==2)
  {
    // The computer won the game. Change the element content in order to explain the new situation to the user.
    // The element is an underlined text. 
    auto tmp = _thedocumentdisplayed->FindObject("id","NeuStarten");
    if(tmp)
    {
      tmp->RemoveSubelements();
      MSHTML_u2* u = new MSHTML_u2();
      *u << new MSHTML_text2("O wins, Restart Game");
      *tmp << u; 
    } 
  }
  if(dreikreuze.Gewonnen()==3)
  {
    // Nobody won the game. Change the element content in order to explain the new situation to the user.
    // The element is an underlined text. 
    auto tmp = _thedocumentdisplayed->FindObject("id","NeuStarten");
    if(tmp)
    {
      tmp->RemoveSubelements();
      MSHTML_u2* u = new MSHTML_u2();
      *u << new MSHTML_text2("nobody wins, Restart Game");
      *tmp << u; 
    } 
  }
}


//! The user clicked on a playing field. Register it and give an reaction -> exchange the displayed image. 
void MSHTMLKontext_Game_Post::KommandoFeld(string feld)
{
  if(dreikreuze.FeldBespielbar(feld))
  {
    auto tmp = _thedocumentdisplayed->FindObject("id","i"+feld);
    if(tmp)
    {
      tmp->ReplaceAttributeContent("src","kreuz.png"); // show a cross
    }
    if(1!=dreikreuze.Gewonnen())
    {
      tmp = _thedocumentdisplayed->FindObject("id","i"+dreikreuze.GebeOFeld());
      if(tmp)
      {
        tmp->ReplaceAttributeContent("src","kreis.png"); // show a circle
      }
    }
  }
}


// The definitions for the Widget scheme



MSHTMLKontext_GameWidget::MSHTMLKontext_GameWidget(MSCoatiApplication2* theapp, const string& coatiid, unsigned int stack_level, map<string,string>& extended_params) 
: MSHTMLKontextN(theapp, coatiid, stack_level,"game_widget.html",extended_params,nullptr)
{
  
  // now loading the game view from the HTML5, store it in thedocumentdisplayed
  _loadDocumentTemplate("spiele_widget.html",_theapp->GetAppstorage().GetStoredPages());
  
   
  // insert the right ID into the document
  insertFormCoatiid(getMainContextID());
    
  // declare all page handlers
  _MS_InsertHandler(as_cmd(CommandGame),"/playwidget");
  _MS_InsertHandler(as_cmd(CommandGame),"/game_widget.html");
  _MS_InsertHandler(as_cmd(CommandRunGetScheme),"/playget");
  _connect_element_method_POST("playget", onclick);
  _MS_InsertHandler(as_cmd(CommandRunPostScheme),"/playpost");
  _connect_element_method_POST("playpost", onclick);
  //thats it
  
  
  map<string,string> params; // formally, not used for this game
  
  auto f = [this](string element, MSXHeader& http_ih)->string{
    
    string antwort = "";
    if(dreikreuze.FeldBespielbar(element.substr(1)))
    {
       antwort += _widgetmanager.ChangeWidgetAttribute(element, "src", "kreuz.png");
       antwort += _widgetmanager.RemoveActionWidgetObject(element,"onclick");
       if(1!=dreikreuze.Gewonnen())
       {
        string reaction = "i"+dreikreuze.GebeOFeld();
        antwort += _widgetmanager.ChangeWidgetAttribute(reaction, "src", "kreis.png");
        antwort += _widgetmanager.RemoveActionWidgetObject(reaction,"onclick");
       }
       switch(dreikreuze.Gewonnen())
       {
        case 1: 
          antwort += _widgetmanager.ChangeWidgetHTML("NeuStartenTxt","X wins, Restart Game");
          break;
        case 2:
          antwort += _widgetmanager.ChangeWidgetHTML("NeuStartenTxt","O wins, Restart Game");
          break;
        case 3:
          antwort += _widgetmanager.ChangeWidgetHTML("NeuStartenTxt","nobody wins, Restart Game");
          break;
       };
    }
    return antwort;
  };
  
  // declare all widget handlers
  _widgetmanager.AddWidgetObject("i11", *this, "onclick",f ,params);
  _widgetmanager.AddWidgetObject("i12", *this, "onclick",f ,params);
  _widgetmanager.AddWidgetObject("i13", *this, "onclick",f ,params);
  _widgetmanager.AddWidgetObject("i21", *this, "onclick",f ,params);
  _widgetmanager.AddWidgetObject("i22", *this, "onclick",f ,params);
  _widgetmanager.AddWidgetObject("i23", *this, "onclick",f ,params);
  _widgetmanager.AddWidgetObject("i31", *this, "onclick",f ,params);
  _widgetmanager.AddWidgetObject("i32", *this, "onclick",f ,params);
  _widgetmanager.AddWidgetObject("i33", *this, "onclick",f ,params);
  _widgetmanager.AddWidgetObject("NeuStartenTxt", *this, "coati",f ,params); // formally, does nothing
  
  auto f1 = [f,this](string element, MSXHeader& http_ih)->string{
    
    string antwort = "";
    // The user wants the game to be initialized again.
    dreikreuze.NeuInitialisieren();
    
    map<string,string> params; // formally, not used for this game
    // declare all widget handler actions for onclick
    antwort += _widgetmanager.AddWidgetObject("i11", *this, "onclick",f ,params);
    antwort += _widgetmanager.AddWidgetObject("i12", *this, "onclick",f ,params);
    antwort += _widgetmanager.AddWidgetObject("i13", *this, "onclick",f ,params);
    antwort += _widgetmanager.AddWidgetObject("i21", *this, "onclick",f ,params);
    antwort += _widgetmanager.AddWidgetObject("i22", *this, "onclick",f ,params);
    antwort += _widgetmanager.AddWidgetObject("i23", *this, "onclick",f ,params);
    antwort += _widgetmanager.AddWidgetObject("i31", *this, "onclick",f ,params);
    antwort += _widgetmanager.AddWidgetObject("i32", *this, "onclick",f ,params);
    antwort += _widgetmanager.AddWidgetObject("i33", *this, "onclick",f ,params);
    
    //reinitialize all widget objects
    antwort += _widgetmanager.ChangeWidgetHTML("NeuStartenTxt","Restart Game");
    antwort += _widgetmanager.ChangeWidgetAttribute("i11", "src", "leer.png");
    antwort += _widgetmanager.ChangeWidgetAttribute("i12", "src", "leer.png");
    antwort += _widgetmanager.ChangeWidgetAttribute("i13", "src", "leer.png");
    antwort += _widgetmanager.ChangeWidgetAttribute("i21", "src", "leer.png");
    antwort += _widgetmanager.ChangeWidgetAttribute("i22", "src", "leer.png");
    antwort += _widgetmanager.ChangeWidgetAttribute("i23", "src", "leer.png");
    antwort += _widgetmanager.ChangeWidgetAttribute("i31", "src", "leer.png");
    antwort += _widgetmanager.ChangeWidgetAttribute("i32", "src", "leer.png");
    antwort += _widgetmanager.ChangeWidgetAttribute("i33", "src", "leer.png");
    
    return antwort;
  };
  _widgetmanager.AddWidgetObject("NeuStarten", *this, "onclick",f1 ,params);
}

MSHTMLKontext_GameWidget::~MSHTMLKontext_GameWidget()
{
  // nothing to do, formally only
}


// the command handlers

void MSHTMLKontext_GameWidget::CommandGame(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
  // just show the page. It is not a real command. Useful if the browser is doing a 'reload' 
  http_oh.setHTTPResponse200(_getBuffer()); // set the new page content
}

void MSHTMLKontext_GameWidget::CommandRunGetScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
  // user wants to play the get scheme
  auto nc = new MSHTMLKontext_Game_Get(_theapp, getMainContextID(), 1, _extended_params);
  nc->manageRequest(http_ih, http_oh, "");
  http_oh.resetKontext(getMainContextID(),nc);
}

void MSHTMLKontext_GameWidget::CommandRunPostScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand)
{
  // user wants to play the get scheme
  auto nc = new MSHTMLKontext_Game_Post(_theapp, getMainContextID(), 1, _extended_params);
  nc->manageRequest(http_ih, http_oh, "");
  http_oh.resetKontext(getMainContextID(),nc);
}


void StorageSetVariables(MSPersistentAppStorage& as)
{
  as.SetStringVariable("COATIRELEASENUMBER", COATIRELEASENUMBER);
  as.SetStringVariable("COATIFRAMEWORK_MAJOR", COATIFRAMEWORK_MAJOR);
  as.SetStringVariable("COATIFRAMEWORK_MINOR", COATIFRAMEWORK_MINOR);
  as.SetStringVariable("COATIFRAMEWORK", COATIFRAMEWORK);
  as.SetStringVariable("TWYMTVERSION", TWYMTVERSION);
  as.SetStringVariable("COATISHORTCOPYRIGHTYY", COATISHORTCOPYRIGHTYY);
  as.SetStringVariable("body:background-color","#F0F0F0");
}


MSSpielApp::MSSpielApp(MSPersistentAppStorage& appstorage, string innerappname, vector<MSCoatiInterfaceProps> _mstp, map<string,string> extended_params) 
: MSCoatiApplication2(appstorage, _mstp, extended_params)
{
}

MSSpielApp::~MSSpielApp()
{
}
     
MSHTMLKontextN* MSSpielApp::createNewContext(const string& prefix)
{
  return insertNewContext(new MSHTMLKontext_Game_Get(this,newID(prefix),1,_extended_params_application));
}

//! the main program
MSAppViewportBase* coatimain(int argc, char* argv[], bool isX)
{


  
 function<MSCoatiApplication2*(MSAppViewportBase*, bool)> start_local = [](MSAppViewportBase* msavb, bool isX)
 {
   MSCoatiApplication2* theapp = nullptr;
  
  check_program(msavb->Argv()[0], msavb->GetAppname(isX));

  cout << "Twymt++ " <<  TWYMTVERSION << " based on CoatiFrame "<< COATIFRAMEWORK << " release#: " << ReleaseNumber() << endl;
  
  string htmlroot = MSGetCurrentDirName();
#ifndef MSANDROIDVERSION
  htmlroot += DataPath("/../htmlroot");
#else
  htmlroot += DataPath("/htmlroot");
#endif
  
/*  
  if(!CheckInstallFiles(htmlroot , 
                        {"kreuz.png","leer.png","kreis.png","mellspa2.png","spiele.html","spiele_post.html","spiele_widget.html","spiele.css"}, 
			"http://www.mellspa.de/Downloads/CoatiGame"))
			
  {
    cout << "Error installing missing files." << endl;
    MS_throw("Error installing missing files.");
  }
 */ 
  // The startpath parameter is used to load the HTML-templates from disk
  map<string,string> params;
  params["startpath"] = "."; //htmlroot;
  
  // getting an instance of the game-class-server on port 0 == "use a free port"
  // do it instructively, not as short as C++ it permits
  
  // Important notice: The next only 4 instructions (and already very long expressed) are needed to implement the 
  // the _whole_ Coati server into an application. All other instructions are preparing the environment for each supported 
  // environment (Linux, Raspberry Pi (command line and X), Android, and Windows (32bit command line or graphical)).
  params["_app_context_commandurl"] = "/";
  params["_baseDirectoryHTTP"] = ".";
  MSCoatiInterfaceProps http("127.0.0.1", 0, MS_PROTOCOL_HTTP);
  vector<MSCoatiInterfaceProps> v;
  v.push_back(http);
  theapp = new MSSpielApp(msavb->GetAppStorage(), "innerappname", v/*, 
				  [](MSHTMLStartKontextN* t, MSCoatiApplication2* a){return new MSHTMLKontext_GameWidget(a,1,t->GetExtendedParams());}*/,
				  params);
  
  log0_out << "going to run" << endl;
  
  
  cout << "App Constructed" << endl;
  
  return theapp;
 };
 
 function <void(MSPersistentAppStorage&)> init_appstorage = [](MSPersistentAppStorage& as){as.SetStoredPages(getstoredpages()); StorageSetVariables(as);};
 
  // the Linux, Android, Raspberry, and Windows case
  return new MSAppViewportBase("XTheGame", "TheGame", start_local, init_appstorage);


}



// organising the program loading stuff
#include <mscoatimain.h>


